
function ScanFX ()
  tab_ref, _ = Utils.getTracksWithFXByPattern('^%u%u%u%d%d_P%d+$')
  return tab_ref
end

function Compare(Ref_tb, Targ_tb)
  for i=1, #Ref_tb do
      local ref  = Ref_tb[i]
      st_len_ref = string.len(Ref_tb[i])
      local targ = Targ_tb[i]
      st_len_targ = string.len(Targ_tb[i])
      local min_len = math.min(#ref, #targ)
      if ref:sub(1,min_len)~=targ:sub(1,min_len) or st_len_targ < st_len_ref then return end
  end
  return true
end

function CheckFX ()
  local proj_change = false
  function Proj_Change()
    local cur_cnt = reaper.GetProjectStateChangeCount(0)
    if not Proj_Change_cnt or cur_cnt ~= Proj_Change_cnt then
      Proj_Change_cnt = cur_cnt
      return true
    end
  end
  proj_change = Proj_Change() -- Проверяет изменился ли проект

  if proj_change == true then
    Targ_tb = ScanFX ()
    Ref_tb = Start_tab_ref

    if Targ_tb then
      Result = Compare(Ref_tb, Targ_tb)
      -- Utils.msg(Result)
      if Result == nil then
        reaper.Main_OnCommand(40029,0) --Undo
      end
    end
  end
  if char ~= -1 then reaper.defer(CheckFX) end -- Следит за GUI скрипта
  -- reaper.defer(CheckFX)
end

-------------------------------------------------------------------------------
-- Set ToolBar Button ON
-- function SetButtonON()
--   is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
--   state = reaper.GetToggleCommandStateEx( sec, cmd )
--   reaper.SetToggleCommandState( sec, cmd, 1 ) -- Set ON
--   reaper.RefreshToolbar2( sec, cmd )
-- end
-- Set ToolBar Button OFF
-- function SetButtonOFF()
--   is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
--   state = reaper.GetToggleCommandStateEx( sec, cmd )
--   reaper.SetToggleCommandState( sec, cmd, 0 ) -- Set OFF
--   reaper.RefreshToolbar2( sec, cmd )
-- end
--------------------------------------------------------------------------------
-- RUN
-- SetButtonON()
Start_tab_ref = ScanFX ()
CheckFX ()

-- reaper.atexit( SetButtonOFF )
