------------------------------------------------------------------------------------------
local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
function get_script_path()
  local info = debug.getinfo(1,'S')
  local script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]
  return script_path
end

local sep = package.config:sub(1, 1) -- получаем правильный для ОС-и сепаратор
local script_path = get_script_path()
------------------------------------------------------------------------------------------
-- 
-- mesg = [=[    Для сохранения настроек Композици,
-- необходимо чтобы были созданы
-- управляющие переключением пресетов айтемы.
-- Нажмите на No Add Control Item,
-- и затем перемещая в нужное место эдит курсор
-- нажимайте нужную кнопку пресета -
-- например - GTR01_P1, GTR01_P2 и т.д.]=]
-- fff = reaper.MB(mesg , "ПРОЧТИТЕ ВНИМАТЕЛЬНО", 0)
--
-- local count_item =  reaper.CountTrackMediaItems( tr )


-- dofile (script_path..sep.."ClientServer.lua")
-- --------------------------------------------------
-- function get_script_path()
--   local filename = debug.getinfo(1, "S").source:match("^@?(.+)$")
--   return filename:match("^(.*)[\\/](.-)$") -- ret script path, name
-- end
-- ----------
-- function get_exe_res_proj_pathes() -- exe, resource, project pathes
--   local exe_path = reaper.GetExePath()
--   local resource_path = reaper.GetResourcePath("")
--   local project_path = reaper.GetProjectPath("")
--   return exe_path, resource_path, project_path
-- end
-- ----------
-- function modify_package_path(new_path) -- add path to package.path
--   package.path = new_path .. "/?.lua;" .. package.path
-- end
--
-- -- Get pathes ------------------------------------
-- local script_path, script_name = get_script_path()
-- local exe_path, resource_path, project_path = get_exe_res_proj_pathes()
--
-- -- Add script path to package.path ---------------
-- modify_package_path(script_path)

dofile (script_path..sep.."utils.lua")
dofile (script_path..sep.."class.lua")
dofile (script_path..sep.."ChunkParser.lua")
dofile (script_path..sep.."FX_Check.lua")
dofile (script_path..sep.."!_InstrumentStack_fromToolbar_5.lua") --Запускает внешний скрипт = Основной скрипт по работе со стэками

--------------------------------------------------------------------------------
local ansi_decode={
  [128]='\208\130',[129]='\208\131',[130]='\226\128\154',[131]='\209\147',[132]='\226\128\158',[133]='\226\128\166',
  [134]='\226\128\160',[135]='\226\128\161',[136]='\226\130\172',[137]='\226\128\176',[138]='\208\137',[139]='\226\128\185',
  [140]='\208\138',[141]='\208\140',[142]='\208\139',[143]='\208\143',[144]='\209\146',[145]='\226\128\152',
  [146]='\226\128\153',[147]='\226\128\156',[148]='\226\128\157',[149]='\226\128\162',[150]='\226\128\147',[151]='\226\128\148',
  [152]='\194\152',[153]='\226\132\162',[154]='\209\153',[155]='\226\128\186',[156]='\209\154',[157]='\209\156',
  [158]='\209\155',[159]='\209\159',[160]='\194\160',[161]='\209\142',[162]='\209\158',[163]='\208\136',
  [164]='\194\164',[165]='\210\144',[166]='\194\166',[167]='\194\167',[168]='\208\129',[169]='\194\169',
  [170]='\208\132',[171]='\194\171',[172]='\194\172',[173]='\194\173',[174]='\194\174',[175]='\208\135',
  [176]='\194\176',[177]='\194\177',[178]='\208\134',[179]='\209\150',[180]='\210\145',[181]='\194\181',
  [182]='\194\182',[183]='\194\183',[184]='\209\145',[185]='\226\132\150',[186]='\209\148',[187]='\194\187',
  [188]='\209\152',[189]='\208\133',[190]='\209\149',[191]='\209\151'
}
local utf8_decode={
  [128]={[147]='\150',[148]='\151',[152]='\145',[153]='\146',[154]='\130',[156]='\147',[157]='\148',[158]='\132',[160]='\134',[161]='\135',[162]='\149',[166]='\133',[176]='\137',[185]='\139',[186]='\155'},
  [130]={[172]='\136'},
  [132]={[150]='\185',[162]='\153'},
  [194]={[152]='\152',[160]='\160',[164]='\164',[166]='\166',[167]='\167',[169]='\169',[171]='\171',[172]='\172',[173]='\173',[174]='\174',[176]='\176',[177]='\177',[181]='\181',[182]='\182',[183]='\183',[187]='\187'},
  [208]={[129]='\168',[130]='\128',[131]='\129',[132]='\170',[133]='\189',[134]='\178',[135]='\175',[136]='\163',[137]='\138',[138]='\140',[139]='\142',[140]='\141',[143]='\143',[144]='\192',[145]='\193',[146]='\194',[147]='\195',[148]='\196',
  [149]='\197',[150]='\198',[151]='\199',[152]='\200',[153]='\201',[154]='\202',[155]='\203',[156]='\204',[157]='\205',[158]='\206',[159]='\207',[160]='\208',[161]='\209',[162]='\210',[163]='\211',[164]='\212',[165]='\213',[166]='\214',
  [167]='\215',[168]='\216',[169]='\217',[170]='\218',[171]='\219',[172]='\220',[173]='\221',[174]='\222',[175]='\223',[176]='\224',[177]='\225',[178]='\226',[179]='\227',[180]='\228',[181]='\229',[182]='\230',[183]='\231',[184]='\232',
  [185]='\233',[186]='\234',[187]='\235',[188]='\236',[189]='\237',[190]='\238',[191]='\239'},
  [209]={[128]='\240',[129]='\241',[130]='\242',[131]='\243',[132]='\244',[133]='\245',[134]='\246',[135]='\247',[136]='\248',[137]='\249',[138]='\250',[139]='\251',[140]='\252',[141]='\253',[142]='\254',[143]='\255',[144]='\161',[145]='\184',
  [146]='\144',[147]='\131',[148]='\186',[149]='\190',[150]='\179',[151]='\191',[152]='\188',[153]='\154',[154]='\156',[155]='\158',[156]='\157',[158]='\162',[159]='\159'},[210]={[144]='\165',[145]='\180'}
}

local nmdc = {
  [36] = '$',
  [124] = '|'
}

function AnsiToUtf8(s)
  local r, b = ''
  for i = 1, s and s:len() or 0 do
    b = s:byte(i)
    if b < 128 then r = r..string.char(b)
    else
      if b > 239 then
        r = r..'\209'..string.char(b - 112)
      elseif b > 191 then
        r = r..'\208'..string.char(b - 48)
      elseif ansi_decode[b] then
        r = r..ansi_decode[b]
      else r = r..'_' end
    end
  end
  return r
end

function Utf8ToAnsi(s)
  local a, j, r, b = 0, 0, ''
  for i = 1, s and s:len() or 0 do
    b = s:byte(i)
    if b < 128 then
      if nmdc[b] then r = r..nmdc[b]
      else r = r..string.char(b) end
    elseif a == 2 then
      a, j = a - 1, b
    elseif a == 1 then
      a, r = a - 1, r..utf8_decode[j][b]
    elseif b == 226 then
      a = 2
    elseif b == 194 or b == 208 or b == 209 or b == 210 then
      j, a = b, 1
    else r = r..'_' end
  end
  return r
end

--------------------------------------------------------------------------------
local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
--------------------------------------------------------------------------------
ToolBarStart = true
---  Default Values  -----------------------------------------------------------
--------------------------------------------------------------------------------
---  Window Def Values  ------------------------
local GUI_TB = {}
GUI_TB = {}
GUI_TB.clear    = 1315860
GUI_TB.title    = "Настройка Концертных Композиций"
GUI_TB.width    = 200.0
GUI_TB.height   = 200.0
GUI_TB.Wnd_Dock = 0
GUI_TB.Wnd_X    = 1200
GUI_TB.Wnd_Y    = 1
---  Some other Default Values  ----------------
local Def_rgba = {0.3, 0.3, 0.3, 1} -- Default r,g,b,a (def color) for btn
local Def_wh   = {80,25}              -- Default w,h for btn
local Def_fnt_lbl, Def_fnt, Def_fnt2, Def_fnt_help
if reaper.GetOS() == "OSX64" then
  Def_fnt_lbl = {"Arial",15}
  Def_fnt  = {"Arial", 13}        -- Default fnt,fnt_sz(use for btn,large elm etc)
  Def_fnt2 = {"Arial", 12}        -- Default fnt,fnt_sz(use little elm etc)
  Def_fnt_help = "Arial", 10
elseif reaper.GetOS() == "Win64" then
  Def_fnt_lbl = {"Arial",18}
  Def_fnt  = {"Arial", 16}        -- Default fnt,fnt_sz(use for btn,large elm etc)
  Def_fnt2 = {"Arial", 15}        -- Default fnt,fnt_sz(use little elm etc)
  Def_fnt_help = "Arial", 14
end

local change   = 0                    -- monitor changes
------------------------------------------------
reaper.Main_OnCommand(40444,0)
----------------------------------------------------------------------------------------
--- LABELS -----------------------------------------------------------------------------
----------------------------------------------------------------------------------------
local lbl1    = {xywh={0,10,445,25},  rgba={1,0.33,0,1}, fnt=Def_fnt_lbl,lbl="Label1"}
-------------------------
local Label_TB = {lbl1} -- Insert labels to Label_TB table
----------------------------------------------------------------------------------------
--- BUTTONS ----------------------------------------------------------------------------
----------------------------------------------------------------------------------------
local OpenCompose   = {type="main",xywh={25,55,145,25}, rgba={0.29,0.61,0.46,0.7}, fnt=Def_fnt, fnt_rgba = {0.8,1,1,1},    lbl="Open Compose Version",  hlp="Open..." }
local SaveComp      = {type="main",xywh={25,90,145,25}, rgba={0.29,0.61,0.46,0.7}, fnt=Def_fnt, fnt_rgba = {0.8,1,1,1},    lbl="Save Compose Version",  hlp="Save..." }
local OpenFinalCompose   = {type="main",xywh={25,135,145,25},  rgba={0.24,0.39,0.54,0.7},   fnt=Def_fnt, fnt_rgba = {0.8,1,1,1},  lbl="Open Final Compose",  hlp="Open..." }
local SaveFinalComp      = {type="main",xywh={25,170,145,25}, rgba={0.24,0.39,0.54,0.7},    fnt=Def_fnt, fnt_rgba = {0.8,1,1,1},  lbl="Save Final Compose",  hlp="Save..." }
local AddControlItem     = {type="main",xywh={25,230,145,25}, rgba={0.54,0.7,0.1,0.7}, fnt=Def_fnt, fnt_rgba = {0.8,1,1,1},  lbl="No Add Control Item",lbl2="Add Control Item", hlp="Add Control Item..." }
local HideGUI    = {type="main",xywh={55,16,85,16}, rgba={0.94,0.7,0.1,0.7}, fnt=Def_fnt2, fnt_rgba = {0.8,1,1,1},  lbl="No Hide GUI",lbl2="Hide GUI", hlp="Hide GUI..." }
local BUTTON_TB = {SaveComp, OpenCompose, OpenFinalCompose, SaveFinalComp, AddControlItem, HideGUI} -- Insert main(control) buttons to BUTTON_TB
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
function CreateScriptFolder (ProjectName) --Функция создаёт папку с именем проекта в папке Рипера - Scripts: В неё дальше складываются все композиции проекта
  ScriptDir = reaper.GetExePath().."\\Scripts\\"..ProjectName
  ChunktDir = reaper.GetExePath().."\\Scripts\\"..ProjectName.."\\Chunk"
  os.execute("mkdir \""..ScriptDir.."\"")
  os.execute("mkdir \""..ChunktDir.."\"")
  dirName = ScriptDir.."\\"
end
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
--  User buttons and label Actions  ----------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
----------Перед сохранение композиции не задействованные трек пресеты убираем из сохранения---------------
function P_Off (track, n_tp, num_tr)
  local n_old = 0
  local n_new = 0
  local tr = track
  local n_tp_f = n_tp
  local num_tr_f = num_tr
  reaper.SetTrackSelected(tr, 1)
  local tm = reaper.GetCursorPosition()
  local _, region_id = reaper.GetLastMarkerAndCurRegion(0, tm)
  local retval, isrgnOut, posOut, rgnendOut, nameOut, markrgnindexnumberOut = reaper.EnumProjectMarkers( region_id )

  reaper.SetEditCurPos(posOut,true,true)
  reaper.Main_OnCommand(40416,0)-- Select and move to previous item

  for i=1, 20 do
    reaper.Main_OnCommand(40417,0)-- Select and move to next item
    local item = reaper.GetSelectedMediaItem(0, 0)
    local tm_startitem = reaper.GetCursorPosition()

    local tm_enditem = tm_startitem + reaper.GetMediaItemInfo_Value(item, 'D_LENGTH')
    local take = reaper.GetActiveTake(item)
    local item_name_n_cursor = reaper.GetTakeName( take )

    n_old = tonumber(item_name_n_cursor:sub(2,-9))

    if n_old > n_new then
      n_new = n_old -- максимальный номер используемогго пресета
    end

    if tm_enditem >= rgnendOut then
      break
    end
  end

  for k = 1, counttracks do
    local track = reaper.GetTrack(0,k-1)
    if track ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
      if tr_name:match(n_tp) then
        fx_count = reaper.TrackFX_GetCount(track) - 1
        FXParamCount = (reaper.TrackFX_GetNumParams(track, 0)) - 2
        z_z = FXParamCount - fx_count - 12
        for i=1, z_z do
          local z = i + 12 + fx_count
          reaper.TrackFX_SetParam(track, 0, z, 0)
        end

        for i=1, num_tr_f - n_new do
          name_pr = n_tp_f..i + n_new -- имена трек-пресетов, которые не используются
          if tr_name:match(name_pr) then
            for i=1, fx_count do
              local z = i + 12
              reaper.TrackFX_SetParam(track, 0, z, 0)
            end
          end
        end
      end
    end
  end
  reaper.SetTrackSelected(tr, 0)
  reaper.Main_OnCommand(40289,0)-- Unselect all item
  reaper.SetEditCurPos(posOut,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
end

counttracks = reaper.CountTracks(0)

function CheckUsePresets ()
  for i = 1, counttracks do
    track = reaper.GetTrack(0,i-1)
    if track ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)

      if tr_name:match('GTR01_Control') then
        n_tp = 'GTR01_P'
        num_tr = 6
        P_Off (track, n_tp, num_tr)
      elseif tr_name:match('BAS01_Control') then
        n_tp = 'BAS01_P'
        num_tr = 5
        P_Off (track, n_tp, num_tr)
      end
    end
  end
end

----------------------------------------------------------------------------------------------------------
function RegionName ()
  local tm = reaper.GetCursorPosition() -- запоминаем позицию курсора
  local _, region_id = reaper.GetLastMarkerAndCurRegion(0, tm)
  local  retval, isrgnOut, posOut, rgnendOut, region_name, markrgnindexnumberOut = reaper.EnumProjectMarkers( region_id )
  compose_name = region_name
  track_2_compose_name = region_name
end
----------------------------------------------------------------------------------------------------------
--- Control Buttons ACTIONS ------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
function FunctionNewComposeExport ()
  dofile (script_path..sep.."Get_Chunk_Compose.lua") -- Загружает внешний скрипт

  --------------------------------------------------------------------------------------------------------
  ------- Секция сохранения настроек всех треков, кроме тех, по которым сохраняем чанки ------------------

  TrackPreset = {}
  function TrackPreset:new(track) -- запоминает всё для Трек Пресетов
    local _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)

    local guid = reaper.GetTrackGUID(track)

    local obj = {}
    obj.exportString = ""

    function obj:addExport(str)
      if str == nil then str = "" end
      obj.exportString = obj.exportString .. str .."\n"
    end
    if track_2_compose_name ~= tr_name then

      obj:addExport("----- "..tr_name.." ----------------------------------------------------------------------- "..tr_name.." ---------------")

      local _, vol, pan = reaper.GetTrackUIVolPan(track)
      local _, vol_0, _ = reaper.GetTrackSendUIVolPan(track, 0)
      local _, vol_1, _ = reaper.GetTrackSendUIVolPan(track, 1)
      local _, vol_2, _ = reaper.GetTrackSendUIVolPan(track, 2)
      local _, vol_3, _ = reaper.GetTrackSendUIVolPan(track, 3)
      local _, vol_4, _ = reaper.GetTrackSendUIVolPan(track, 4)

      obj:addExport("     reaper.SetMediaTrackInfo_Value(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), \"D_VOL\", "..vol..")")
      obj:addExport("     reaper.SetMediaTrackInfo_Value(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), \"D_PAN\", "..pan..")")

      if tr_name ~= "PreMaster" then
        obj:addExport("     reaper.SetTrackSendUIVol(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), 0, "..vol_0..", 0)")
        obj:addExport("     reaper.SetTrackSendUIVol(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), 1, "..vol_1..", 0)")
        obj:addExport("     reaper.SetTrackSendUIVol(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), 2, "..vol_2..", 0)")
        obj:addExport("     reaper.SetTrackSendUIVol(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), 3, "..vol_3..", 0)")
        obj:addExport("     reaper.SetTrackSendUIVol(reaper.BR_GetMediaTrackByGUID(0, \""..guid.."\"), 4, "..vol_4..", 0)")
      end

    end

    function obj:export()
      return obj.exportString
    end

    return obj
  end

  local patterns = {}
  patterns["^%u%u%u%d%d_P%d+$"] = TrackPreset

  function exportComposition()
    local string = ""
    local counttracks = reaper.CountTracks(0)
    if counttracks == nil then return end
    -- add tracks
    for i = 1, counttracks do
      local track = reaper.GetTrack(0,i-1)
      if track ~= nil then
        _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
        for k, v in pairs(patterns) do
          if not tr_name:match(k)
          and not tr_name:match("^Separatot")
          and not tr_name:match("^Separator")
          and not tr_name:match("^%u%u%u%d%d_IN")
          and not tr_name:match("^%u%u%u%d%d_Control")
          and not tr_name:match("^Parallel DRUMS")
          and not tr_name:match("^KICK PAR")
          and not tr_name:match("^SNARE PAR")
          and not tr_name:match("^TOMS PAR")
          and not tr_name:match("^Studio DRUMS")
          and not tr_name:match("^MIX_")
          and not tr_name:match("^!_")
          and not tr_name:match("^%d%d %u%u+")
          and not tr_name:match("^CLICK")
          and not tr_name:match("^SYSTEM")
          and not tr_name:match("^[*]")then
            local tr = v:new(track)
            string = string..tr:export()
          end
        end
      end
    end
    return string
  end

  NewComposeExport_02 = exportComposition()
  NewComposeExport_02 = NewComposeExport_02..[[

  -- local tr_drum_bus = reaper.GetTrack(0, 25) -- Для DRUM BUS трека (1)
  -- local tr_drum_bus_vol = reaper.GetMediaTrackInfo_Value(tr_drum_bus, 'D_VOL')
  --
  -- local tr_studio_drums = reaper.GetTrack(0, 30) -- Для Studio DRUMS трека (60)
  -- for i = 1, 7 do
  --   reaper.SetTrackSendUIVol(tr_studio_drums, i-1, tr_drum_bus_vol, 0) -- Выставляет уровень посылов на персональные миксы равный уровню громкости Буса
  -- end
end
compose_status = 1
if fx_par == 0 then reaper.defer(ClickStart) end -- Следит за кликом
end
ClickStart ()
]]
-- ----------------------------------------------------------------------------------------
-- local tr_drum_bus = reaper.GetTrack(0, 25) -- Для DRUM BUS трека (1)
-- local tr_drum_bus_vol = reaper.GetMediaTrackInfo_Value(tr_drum_bus, 'D_VOL')
--
-- local tr_studio_drums = reaper.GetTrack(0, 30) -- Для Studio DRUMS трека (60)
-- for i = 1, 7 do
--   reaper.SetTrackSendUIVol(tr_studio_drums, i-1, tr_drum_bus_vol, 0) -- Выставляет уровень посылов на персональные миксы равный уровню громкости Буса
-- end
----------------------------------------------------------------------------------------
local tm = reaper.GetCursorPosition() -- запоминаем позицию курсора
local _, region_id = reaper.GetLastMarkerAndCurRegion(0, tm)
local regcompose_id = region_id+1

NewComposeExport_01 = [[
compose_status = 0

local track_comp = reaper.GetTrack(0,1)
_, get_track_compose_name = reaper.GetSetMediaTrackInfo_String(track_comp, 'P_NAME', "", false)
track_compose_name = ']]..compose_name..[['

local tr_Click = reaper.GetTrack(0, 2) -- Для Click Трэка
reaper.TrackFX_SetParam(tr_Click, 0, 1, 0) -- выключает на коде композиции клик

Track = class(function(a, track, chunk)
  a.track = track
  a.chunk = chunk
  a.chunkIsSet = false
end)

function Track:setChunk()
  reaper.SetTrackStateChunk( self.track, self.chunk, false )
  self.chunkIsSet = true
end

function Track:canSetChunk()
  return self:getVolumeOut() == 0
end

function Track:getVolumeOut()
  local _, volumeOut, _ = reaper.GetTrackSendUIVolPan(self.track, 0)
  return volumeOut
end

separator = "#####################\n"
local filename = reaper.GetExePath().."\\Scripts\\]]..chunknamepath..[[.txt"]].."\n"..[[
data_s = Utils.readStringFromFile(filename)

chunks = Utils.explode(separator, data_s)
local tracks = {}

for i=1, #chunks do
  local chunk = chunks[i]
  chunk = string.gsub(chunk, "%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#?", "")
  local guid_x = string.match(chunk, "TRACKID ({[^}]+})")
  local track = reaper.BR_GetMediaTrackByGUID( 0, guid_x )
  table.insert(tracks, Track(track, chunk))
end

function setAvailableChunks()
  for i=1, #tracks do
    local tr = tracks[i]
    if ToolBarStart == true then
      if tr.chunkIsSet ~= true then
        tr:setChunk()
        if tr:getVolumeOut() == 1 then
          turnFX_On_Off(tr.track,1)
        end
      end
    else
      if tr.chunkIsSet ~= true and tr:canSetChunk() then
        tr:setChunk()
      end
    end

  end
end

function allChunksSet()
  for i=1, #tracks do
    local tr = tracks[i]
    if tr.chunkIsSet ~= true then return false end
  end
  return true
end

function try()
  if (allChunksSet() ~= true) then
    setAvailableChunks()
    reaper.defer(function()
      try()
    end)
  end
end
try()

reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWSTL_SHOWALLMCP"), 0)
timeout(1, function()
  reaper.GetSetMediaTrackInfo_String(track_comp, 'P_NAME', track_compose_name, true)
end)
function ClickStart ()
  local tr = reaper.GetTrack(0, 2) -- Для Click
  local fx_par = reaper.TrackFX_GetParam(tr, 0, 1)
  if fx_par == 1 then
    ]]
  end

  function timeoutCheckAllChunksInProject(folder, lastChunkPath)
    timeout(1, function()
      checkAllChunksInProject(folder, lastChunkPath)
    end)
  end

  function checkAllChunksInProject(folder, lastChunkPath)
    local lastFile = File(lastChunkPath)
    local fileslist = Utils.scandir(folder, "*.txt")
    for i=1,#fileslist do
      local file = File(fileslist[i])
      if file.path ~= lastFile.path then

        for j=1,#file.tracks do
          local track = file.tracks[j]
          -- msg(lastChunkPath)
          -- msg(track.id)
          -- msg(file.path)
          local lastTrack = lastFile:findTrackById(track.id)

          local fxCount = 0
          if track.fxs ~= nil then
            fxCount = #track.fxs
          end

          local lastFxCount = 0
          if lastTrack ~= nil and lastTrack.fxs ~= nil then
            lastFxCount = #lastTrack.fxs
          end

          if fxCount ~= lastFxCount and lastTrack ~= nil then
            for k=1,#lastTrack.fxs do
              local lastFx = lastTrack.fxs[k]
              local foundFx = track:findFxById(lastFx.id)
              if foundFx == nil then
                file.tracks[j]:addFx(lastFx)
              end
            end
          end

        end
        file:save()
      end
    end
  end

  ----------------------------------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------------------------------
  SaveComp.Action = function ()
    reaper.Main_OnCommand(reaper.NamedCommandLookup("_S&M_WNCLS3"), 0) -- Перед сохранением закрыть все окна плагинов
    reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWSTL_SHOWALLMCP"), 0)-- Перед сохранением сделать видимыми все треки в микшере

    CheckUsePresets () -- запускает сканирование использовавшихся трек пресетов

    YES = false
    Start_tab_ref = ScanFX ()
    ----------------------------------------------------------------------------------------------------------
    for i=1, #tracks do
      local trackObject = tracks[i]

      if trackObject.isTrackPreset then
        local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
        if trackObject.isP1Preset then
          turnFX_On_Off (track,1)
          reaper.SetTrackSendUIVol(track, 0, 1, 0)
          reaper.TrackFX_SetParam(track, 0, 0, 0)
          reaper.TrackFX_SetParam(track, 0, 3, 1)
          timeout(0.1, function()
            reaper.TrackFX_SetParam(track, 0, 1, 1)
          end)
        else
          timeout(0.2, function()
            turnFX_On_Off (track,0)
            reaper.SetTrackSendUIVol(track, 0, 0, 0)
            reaper.TrackFX_SetParam(track, 0, 0, -80)
            reaper.TrackFX_SetParam(track, 0, 3, 0)
          end)
        end
      end
    end
    --------------------------------------------------------------------------------------------------------
    RegionName ()
    local track_comp = reaper.GetTrack(0,1) --Трек с наименованием Региона
    reaper.GetSetMediaTrackInfo_String(track_comp, 'P_NAME', track_2_compose_name, true)
    -- reaper.Main_OnCommand(40444,0)
    reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI



    if compose_name:match(".") then -- Проверяет, что над курсором есть регион
      timeout(0.6, function()

        ComposeScriptDir = ScriptDir..[[\\]]..compose_name..[[\\]]
        ComposeChunktDir = ChunktDir..[[\\]]..compose_name

        os.execute("mkdir \""..ComposeScriptDir.."\"")
        os.execute("mkdir \""..ComposeChunktDir.."\"")

        _, user_input = reaper.GetUserInputs("Save Compose as", 1, "Compose suffix:", "")
        if user_input:match(".") then -- Проверяет: что пользователь хоть что-то внёс как имя
          tr_name_ansi = Utf8ToAnsi(user_input)
          if tr_name_ansi then
            tr_name_ansi_lower = tr_name_ansi:lower()
            tr_name_utf_lower = AnsiToUtf8(tr_name_ansi_lower)
            numb_version = tr_name_utf_lower
          end

        else
          return
        end

        -- numb_version = #Compose

        compose_numb_version = "_"..numb_version
        name_of_composes = compose_name..compose_numb_version

        chunknamepath = proj_nm..[[\\Chunk\\]]..compose_name..[[\\]]..name_of_composes

        gfx.x, gfx.y = 20,100
        menu = gfx.showmenu( menu_str )

        FunctionNewComposeExport ()
        timeoutCheckAllChunksInProject(ChunktDir.."\\", reaper.GetExePath().."\\Scripts\\"..proj_nm..[[\Chunk\]]..compose_name.."\\"..name_of_composes..".txt")

        finalExport = NewComposeExport_01..NewComposeExport_02
        ------------------------------------------------------------------------------
        ------------------------------------------------------------------------------

        outfile = io.open(dirName..compose_name..[[\\]]..name_of_composes..".lua", "w")
        outfile:write(finalExport)
        outfile:close()

        ScNameShot = name_of_composes --Отправляет имя Композиции (скрипта) в GUI (Инфо лэйбл) при её сохранении
      end)

      timeout(1.2, function()
        YES = true
      end)
    else
      mesg = [=[    Для сохранения настроек Композици,
      необходимо чтобы курсор находился
      в пределах Региона композиции.]=]
      fff = reaper.MB(mesg , "ПРОЧТИТЕ ВНИМАТЕЛЬНО", 0)
    end

  end
  ----------------------------------------------------------------------------------------------------------
  SaveFinalComp.Action = function ()
    reaper.Main_OnCommand(reaper.NamedCommandLookup("_S&M_WNCLS3"), 0) -- Перед сохранением закрыть все окна плагинов
    reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWSTL_SHOWALLMCP"), 0)-- Перед сохранением сделать видимыми все треки в микшере

    CheckUsePresets () -- запускает сканирование использовавшихся трек пресетов

    YES = false
    Start_tab_ref = ScanFX ()
    ----------------------------------------------------------------------------------------------------------
    for i=1, #tracks do
      local trackObject = tracks[i]


      if trackObject.isTrackPreset then
        local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
        if trackObject.isP1Preset then
          turnFX_On_Off (track,1)
          reaper.SetTrackSendUIVol(track, 0, 1, 0)
          reaper.TrackFX_SetParam(track, 0, 0, 0)
          reaper.TrackFX_SetParam(track, 0, 3, 1)
          timeout(0.1, function()
            reaper.TrackFX_SetParam(track, 0, 1, 1)
          end)
        else
          timeout(0.2, function()
            turnFX_On_Off (track,0)
            reaper.SetTrackSendUIVol(track, 0, 0, 0)
            reaper.TrackFX_SetParam(track, 0, 0, -80)
            reaper.TrackFX_SetParam(track, 0, 3, 0)
          end)
        end
      end
    end
    --------------------------------------------------------------------------------------------------------

    RegionName ()
    local track_comp = reaper.GetTrack(0,1) --Трек с наименованием региона
    reaper.GetSetMediaTrackInfo_String(track_comp, 'P_NAME', track_2_compose_name, true)
    reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI

    if compose_name:match(".") then -- Проверяет, что над курсором есть регион
      timeout(0.6, function()

        ComposeScriptDir = ScriptDir..[[\\]]
        ComposeChunktDir = ChunktDir..[[\\]]

        os.execute("mkdir \""..ComposeScriptDir.."\"")
        os.execute("mkdir \""..ComposeChunktDir.."\"")

        Compose = {}
        i=0
        while i<100 and file_name~="" do
          file_name = reaper.EnumerateFiles(ComposeScriptDir, i)
          if file_name then
            table.insert(Compose, file_name)

          end
          i=i+1
        end

        numb_version = #Compose

        compose_numb_version = "_"..numb_version
        name_of_composes = compose_name..compose_numb_version
        chunknamepath = proj_nm..[[\\Chunk\\]]..compose_name

        gfx.x, gfx.y = 20,100
        menu = gfx.showmenu( menu_str )

        FunctionNewComposeExport ()
        timeoutCheckAllChunksInProject(ChunktDir.."\\", reaper.GetExePath().."\\Scripts\\"..proj_nm..[[\\Chunk\\]]..compose_name..".txt")

        finalExport = NewComposeExport_01..NewComposeExport_02
        ------------------------------------------------------------------------------
        ------------------------------------------------------------------------------

        outfile = io.open(dirName..compose_name..".lua", "w")
        outfile:write(finalExport)
        outfile:close()

        ScNameShot = compose_name --Отправляет имя Композиции (скрипта) в GUI (Инфо лэйбл) при её сохранении
      end)

      timeout(1.2, function()
        YES = true
      end)
    else
      mesg = [=[    Для сохранения настроек Композици,
      необходимо чтобы курсор находился
      в пределах Региона композиции.]=]
      fff = reaper.MB(mesg , "ПРОЧТИТЕ ВНИМАТЕЛЬНО", 0)
    end

  end
  ----------------------------------------------------------------------------------------------------------
  OpenCompose.Action = function () -- Генерит Меню со списком уже созданных Композиций
    YES = false

    local counttracks = reaper.CountTracks(0)
    if counttracks == nil then return end

    menu_str =">Open Compose Version"

    RegionName ()

    ComposeScriptDir = ScriptDir..[[\\]]..compose_name..[[\\]]
    ComposeChunktDir = ChunktDir..[[\\]]..compose_name

    Compose = {}
    i=0
    while i<100 and file_name~="" do
      file_name = reaper.EnumerateFiles(ComposeScriptDir, i)

      if file_name then
        menu_str = menu_str.."|"..string.sub(tostring(file_name),0,-5)
        table.insert(Compose, file_name)
      end
      i=i+1
    end

    gfx.x, gfx.y = 20,60
    menu = gfx.showmenu( menu_str )

    if Compose[menu] ~= nil then
      ----------------------------------------------------------------------------------------------------------
      for i=1, #tracks do
        local trackObject = tracks[i]

        if trackObject.isTrackPreset then
          local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
          if trackObject.isP1Preset then
            turnFX_On_Off (track,1)
            reaper.SetTrackSendUIVol(track, 0, 1, 0)
            reaper.TrackFX_SetParam(track, 0, 0, 0)
            reaper.TrackFX_SetParam(track, 0, 3, 1)
            timeout(0.1, function()
              reaper.TrackFX_SetParam(track, 0, 1, 1)
            end)
          else
            timeout(0.2, function()
              turnFX_On_Off (track,0)
              reaper.SetTrackSendUIVol(track, 0, 0, 0)
              reaper.TrackFX_SetParam(track, 0, 0, -80)
              reaper.TrackFX_SetParam(track, 0, 3, 0)
            end)
          end
        end
      end
      ----------------------------------------------------------------------------------------------------------
      ScName = ComposeScriptDir..Compose[menu]
      ScNameShot = string.sub(Compose[menu],1,-5) -- Сохраняет в переменную строку без последних 4-х символов (.lua)

      _, _, num_regionsOut = reaper.CountProjectMarkers(0)

      timeout(0.8, function()
        dofile (ScName) -- Загружает выбранный в меню скрипт (композицию)

        for i=1, num_regionsOut do
          _, _, pos_reg, _, region_name, _ = reaper.EnumProjectMarkers(i-1)

          if region_name == ScNameShot then
            reaper.SetEditCurPos(pos_reg,true,true)
          end
        end

        reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
      end)
      timeout(1.2, function()
        YES = true
      end)
    end
  end
  ----------------------------------------------------------------------------------------------------------
  OpenFinalCompose.Action = function () -- Генерит Меню со списком уже созданных Композиций
    YES = false

    local counttracks = reaper.CountTracks(0)
    if counttracks == nil then return end

    menu_str =">Open Final Compose"

    RegionName ()

    ComposeScriptDir = ScriptDir..[[\\]]
    ComposeChunktDir = ChunktDir..[[\\]]

    Compose = {}
    i=0
    while i<100 and file_name~="" do
      file_name = reaper.EnumerateFiles(ComposeScriptDir, i)
      if file_name then
        menu_str = menu_str.."|"..string.sub(tostring(file_name),0,-5)
        table.insert(Compose, file_name)
      end
      i=i+1
    end

    gfx.x, gfx.y = 20,135
    menu = gfx.showmenu( menu_str )

    if Compose[menu] ~= nil then
      ----------------------------------------------------------------------------------------------------------
      for i=1, #tracks do
        local trackObject = tracks[i]

        if trackObject.isTrackPreset then
          local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
          if trackObject.isP1Preset then
            turnFX_On_Off (track,1)
            reaper.SetTrackSendUIVol(track, 0, 1, 0)
            reaper.TrackFX_SetParam(track, 0, 0, 0)
            reaper.TrackFX_SetParam(track, 0, 3, 1)
            timeout(0.1, function()
              reaper.TrackFX_SetParam(track, 0, 1, 1)
            end)
          else
            timeout(0.2, function()
              turnFX_On_Off (track,0)
              reaper.SetTrackSendUIVol(track, 0, 0, 0)
              reaper.TrackFX_SetParam(track, 0, 0, -80)
              reaper.TrackFX_SetParam(track, 0, 3, 0)
            end)
          end
        end
      end
      ----------------------------------------------------------------------------------------------------------
      ScName = ComposeScriptDir..Compose[menu]
      ScNameShot = string.sub(Compose[menu],1,-5) -- Сохраняет в переменную строку без последних 4-х символов (.lua)

      _, _, num_regionsOut = reaper.CountProjectMarkers(0)

      timeout(0.4, function()
        dofile (ScName) -- Загружает выбранный в меню скрипт (композицию)

        for i=1, num_regionsOut do
          _, _, pos_reg, _, region_name, _ = reaper.EnumProjectMarkers(i-1)
          if region_name == ScNameShot then
            reaper.SetEditCurPos(pos_reg,true,true)
          end
        end

        reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
      end)
      timeout(1.2, function()
        YES = true
      end)
    end
  end
  --------------------------------------------------------------------------------------
  AddMIDI = false
  --------------------------------------------------------------------------------------
  AddControlItem.Action = function(btn)
    if btn.tgl_state then AddMIDI = false
    else AddMIDI = true
    end
    btn.tgl_state     = not btn.tgl_state
    btn.lbl, btn.lbl2 = btn.lbl2, btn.lbl
  end
  --------------------------------------------------------------------------------------
  lbl1.Action = function()
    if ScNameShot then
      return ScNameShot --Отправляет имя Композиции (скрипта) в GUI (Инфо лэйбл) при её вызове
    else
      return "No Compose"
    end
  end

  --------------------------------------------------------------------------------
  -- Ations for tr_ctrl and gr_ctrl buttons --------------------------------------
  --------------------------------------------------------------------------------
  function track_btn_Action(btn)
    if not groups[btn.group].activeInGui then return end
    -----
    local track = reaper.BR_GetMediaTrackByGUID(0, btn.guid)
    reaper.TrackFX_SetParam(track, 0, 1, 1) -- track(byGuid), fx(0), par(1), val(1)
    ------------------------------------------------------------------------------
    reaper.Main_OnCommand(40289,0) -- Unselect all item
    -- reaper.Main_OnCommand(40297,0) -- Unselect all track

    -- _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)

    Guid_to_track = btn.guid

    if AddMIDI == true then
      dofile (script_path..sep.."AddMIDI_CC.lua") -- Загружает внешний скрипт
    end
  end

  ------------------------------------------------------------------------
  ------------------------------------------------------------------------
  function track_btn_Action_R(btn)
    if not groups[btn.group].activeInGui then return end
    -----
    local track = reaper.BR_GetMediaTrackByGUID(0, btn.guid)
    reaper.TrackFX_SetOpen(track, 0, true)
  end

  ------------------------------------------------------------------------
  ------------------------------------------------------------------------
  function group_btn_Action(btn)
    groups[btn.group].activeInGui = not groups[btn.group].activeInGui
    local Group = btn.group; Group_NewState = groups[btn.group].activeInGui
    for i=1, #tracks do
      if tracks[i].group == Group then
        local guid = tracks[i].guid
        local tr = reaper.BR_GetMediaTrackByGUID( 0, guid )
        local _, tr_name = reaper.GetSetMediaTrackInfo_String(tr, 'P_NAME', '', false)
        if not tr_name:match('_Out$') then
          if Group_NewState == false then
            reaper.SetMediaTrackInfo_Value( tr, "B_SHOWINMIXER", 0 )
          else
            reaper.SetMediaTrackInfo_Value( tr, "B_SHOWINMIXER", 1 )
          end
          reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
        end

      end
    end
  end

  --------------------------------------------------------------------------------
  ---  Buttons from Project tracks  ----------------------------------------------
  --------------------------------------------------------------------------------

  function Buttons_from_Proj_tracks()
    local S_x,S_y, x,y,w,h, r,g,b,a, name,guid
    w, h = table.unpack(Def_wh)       -- set default values
    x, y = 200-w,55                   -- start x, y coord for btns
    r,g,b,a = table.unpack(Def_rgba)  -- set def values
    S_x = x; S_y = y

    ------------------------------
    for i=1, #tracks do local track = tracks[i] -- track from tracks table
      -------- new group_btn --------
      if track.isOut then
        groups[track.group].activeInGui = true  -- default is active
        y = S_y                                 -- y coord for new group_btn(start y)
        x = x+w+10                              -- x coord for new group_btn
        GUI_TB.width = math.max(x+w+20, GUI_TB.width)  -- update window w
        -----
        local group_btn = {type = "gr_ctrl", group = track.group,
        Action = group_btn_Action,
        xywh = {x,y,w,h}, rgba = {0.51,0.6,0.68,a},
        fnt = Def_fnt, fnt_rgba = {0.1,0.1,0.1,1}, lbl = track.name, hlp = "Кнопка вкл/выкл групп Трек-Роесетов",
      }
      table.insert(BUTTON_TB, group_btn)
    end
    -------- New track_btn --------
    if track.isTrackPreset then
      y = y+h+10                              -- y coord for new track_btn
      GUI_TB.height = math.max(y+h+20, GUI_TB.height) -- update window h
      if GUI_TB.height <= 275 then
        GUI_TB.height = 275
      end
      -----
      local track_btn = {type = "tr_ctrl", group = track.group, guid = track.guid,
      Action   = track_btn_Action,
      Action_R = track_btn_Action_R,
      xywh = {x,y,w,h}, rgba = {r,g,b,a},
      fnt = Def_fnt, fnt_rgba = {0.8,1,0,1}, lbl = track.name, hlp = "Кнопка переключения на соответствующий Трек-Пресет",
    }
    table.insert(BUTTON_TB, track_btn)
  end
end
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--  Label  ---------------------------------------------------------------------
--------------------------------------------------------------------------------
function draw_lbl(lbl)
  local x, y, w, h = table.unpack(lbl.xywh)  --x,y,w,h
  local r, g, b, a = table.unpack(lbl.rgba)  --r,g,b,a
  local fnt,fnt_sz = table.unpack(lbl.fnt)   --fnt,fnt_sz
  --------
  gfx.set(r, g, b, a)                      --set color
  gfx.setfont(1,fnt,fnt_sz);
  lbl.lbl = lbl.Action()
  local lbl_w, lbl_h = gfx.measurestr(lbl.lbl)
  gfx.x = x+(w-lbl_w)/2; gfx.y = y+(h-lbl_h)/2
  gfx.drawstr(lbl.lbl)
  --------
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--  Get Mouse  -----------------------------------------------------------------
--------------------------------------------------------------------------------
function pointIN(p_x, p_y,  x,y,w,h)
  return p_x >= x and p_x <= x + w and p_y >= y and p_y <= y + h
end
--------
function mouseDown(x,y,w,h)
  return gfx.mouse_cap&1==1 and pointIN(mouse_ox,mouse_oy, x,y,w,h)
end
--------
function mouseIN(x,y,w,h)
  return gfx.mouse_cap&1==0 and pointIN(gfx.mouse_x,gfx.mouse_y, x,y,w,h)
end

--------
function mouseClick(x,y,w,h)
  return gfx.mouse_cap&1==0 and last_mouse_cap&1==1 and
  pointIN(gfx.mouse_x,gfx.mouse_y, x,y,w,h) and pointIN(mouse_ox,mouse_oy, x,y,w,h)
end
--------
function mouseR_Down(x,y,w,h)
  return gfx.mouse_cap&2==2 and last_mouse_cap&2==0 and pointIN(mouse_ox,mouse_oy, x,y,w,h)
end
--------------------------------------------------------------------------------
-- Draw help string ------------------------------------------------------------
--------------------------------------------------------------------------------
function help_str(string)
  gfx.x, gfx.y = 2, 2; gfx.set(1, 1, 0.7, 1);
  gfx.setfont(1, Def_fnt_help); gfx.drawstr(string)
end

--------------------------------------------------------------------------------
--  BUTTON  --------------------------------------------------------------------
--------------------------------------------------------------------------------
function draw_btn(btn)
  local x, y, w, h = table.unpack(btn.xywh) -- x,y,w,h
  local r, g, b, a = table.unpack(btn.rgba) -- r,g,b,a
  local fnt,fnt_sz = table.unpack(btn.fnt)  -- fnt,fnt_sz
  local fr, fg, fb, fa = table.unpack(btn.fnt_rgba) -- r,g,b,a
  -------------------------------------------
  -- Get mouse ------------------------------
  -- in element -------------
  if mouseIN(x,y,w,h)    then a = a + 0.1
    help_str(btn.hlp) -- help string
  end
  -- in elm L_down ----------
  if mouseDown(x,y,w,h)  then a = a + 0.2 end
  -- in elm L_up(released) --
  if mouseClick(x,y,w,h) and btn.Action then btn.Action(btn) end -- L click
  -- in elm R_down ----------
  if mouseR_Down(x,y,w,h) and btn.Action_R then btn.Action_R(btn) end -- R down
  -----------------------------------------------------------------------------
  -- Change "tr_ctrl" btn tgl_state externaly (depend of FX parameter state) --
  -- msg(YES)
  if YES == true and btn.type=="tr_ctrl" then local track = reaper.BR_GetMediaTrackByGUID(0, btn.guid)
    _, volumeOut, _ = reaper.GetTrackSendUIVolPan( track, 0 )
    -- if reaper.TrackFX_GetParam(track, 0, 0)==0 then btn.tgl_state = true
    if volumeOut==1 then
      btn.tgl_state = true
    else
      btn.tgl_state = false
    end
    if btn.tgl_state==true then SnapShot_bypas_unbypas(btn.guid) end
  end

  ------------------------------------------------------
  -- Highlight buttons  --------------------------------
  if btn.tgl_state==true then r,g,b = 0.1, 0.3, 0.1 end
  if (btn.type=="tr_ctrl" or btn.type=="gr_ctrl") and not groups[btn.group].activeInGui then
    a = 0.1
    fa = 0.1
  end
  -------------------------------------------
  -------------------------------------------
  -- Draw button --
  gfx.set(r,g,b,a)                           -- set body color
  gfx.rect(x,y,w,h,true)                     -- draw button body
  gfx.set(r-0.2, g-0.2, b-0.2, a)            -- set frame color
  gfx.rect(x, y, w, h, false)                -- button frame1
  gfx.roundrect(x+1, y+1, w-3, h-3, 4, true) -- button frame2
  -- Draw button lbl(text) --
  --gfx.set(0.7, 1, 0, a+0.1)
  gfx.set(fr, fg, fb, fa)
  gfx.setfont(1,fnt,fnt_sz)
  local lbl_w, lbl_h = gfx.measurestr(btn.lbl)
  gfx.x = x+(w-lbl_w)/2; gfx.y = y+(h-lbl_h)/2
  gfx.drawstr(btn.lbl)
  ----------
end

--------------------------------------------------------------------------------
--  DRAW -----------------------------------------------------------------------
--------------------------------------------------------------------------------
--  Main draw function  --------
function Draw()
  for key,btn in pairs(BUTTON_TB) do draw_btn(btn) end
  ----------
  for key,lbl in pairs(Label_TB) do draw_lbl(lbl) end
end

--------------------------------------------------------------------------------
-- Bypas/Unbypas check Function ------------------------------------------------
--------------------------------------------------------------------------------
function SnapShot_bypas_unbypas(guid_btn)
  -- if toTrack_N then
  local track = reaper.BR_GetMediaTrackByGUID(0, guid_btn)
  -- local track = toTrack_N
  volumeOut = reaper.TrackFX_GetParam(track, 0, 3)
  if volumeOut >= 0.99999  then
    countFX = reaper.TrackFX_GetCount(track)-1
    for i=1, countFX do
      n = reaper.TrackFX_GetEnabled(track, i)
      n1 = reaper.TrackFX_GetParam(track, 0, i+12)
      if n == true then
        s_fx=1
      else
        s_fx=0
      end
      if s_fx ~= n1 then
        reaper.TrackFX_SetParam(track, 0, i+12, s_fx)
      end
    end
  end
  -- end
end
------------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Set ToolBar Button ON -------------------------------------------------------
--------------------------------------------------------------------------------
function SetButtonON()
  ------------------------------------------------------------------------------
  --Сбрасываем в 0 Лок на обучении плагина AF
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return end
  for i = 1, counttracks do
    track = reaper.GetTrack(0,i-1)
    if track ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
      if tr_name:match('^%u%u%u%d%d_P%d+$') then
        reaper.TrackFX_SetParam(track, 0, 6, 0)
      end
    end
  end
  ------------------------------------------------------------------------------

  local is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
  state = reaper.GetToggleCommandStateEx( sec, cmd )
  reaper.SetToggleCommandState( sec, cmd, 1 ) -- Set ON
  reaper.RefreshToolbar2( sec, cmd )
end


--------------------------------------------------------------------------------
-- Set ToolBar Button OFF ------------------------------------------------------
--------------------------------------------------------------------------------
function SetButtonOFF()
  ------------------------------------------------------------------------------
  --Взводим Лок (параметр = 1) на обучении плагина AF - нужно для того, чтоб потом работал основной скрипт
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return end
  for i = 1, counttracks do
    track = reaper.GetTrack(0,i-1)
    if track ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
      if tr_name:match('^%u%u%u%d%d_P%d+$') then
        -- if not tr_name:match('^%u%u%u%d%d_P0') then
        reaper.TrackFX_SetParam(track, 0, 6, 1)
        -- end
      end
    end
  end
  ------------------------------------------------------------------------------
  local is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
  state = reaper.GetToggleCommandStateEx( sec, cmd )
  reaper.SetToggleCommandState( sec, cmd, 0 ) -- Set OFF
  reaper.RefreshToolbar2( sec, cmd )
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
----  INIT  --------------------------------------------------------------------
--------------------------------------------------------------------------------
function init()
  gfx.clear = GUI_TB.clear    -- clear = red+green*256+blue*65536
  gfx.init(GUI_TB.title,GUI_TB.width,GUI_TB.height,GUI_TB.Wnd_Dock,GUI_TB.Wnd_X,GUI_TB.Wnd_Y)
  mouse_ox, mouse_oy = 0, 0   -- Mouse click coordinates
  last_mouse_cap = 0          -- last mouse cap
end
--------------------------------------------------------------------------------
function init_gfx(Name,width,height,dockstate,xpos,ypos)
  gfx.quit()
  gfx.init(Name,width,height,dockstate,xpos,ypos)
end


---------------------------------------------------------------------------------
HideGUI.Action = function(btn)
  if btn.tgl_state then
    init_gfx(GUI_TB.title,GUI_TB.width,GUI_TB.height,GUI_TB.Wnd_Dock,GUI_TB.Wnd_X,GUI_TB.Wnd_Y)
  else
    timeout(0.1, function()
      init_gfx("Интерфейс свёрнут - кликните кнопку Hide GUI",GUI_TB.width,40,GUI_TB.Wnd_Dock,1200,1)
    end)
  end
  btn.tgl_state     = not btn.tgl_state
  btn.lbl, btn.lbl2 = btn.lbl2, btn.lbl
end

-- Mainloop --------------------------------------------------------------------
--------------------------------------------------------------------------------
function mainloop()
  local tr = reaper.GetTrack(0, 2) -- Для Click
  local fx_par = reaper.TrackFX_GetParam(tr, 0, 1)
  if fx_par == 0 then
    reaper.TrackFX_SetParam(tr, 0, 1, 1)
  end


  if gfx.mouse_cap&1==1 and last_mouse_cap&1==0 then mouse_ox,mouse_oy = gfx.mouse_x, gfx.mouse_y end
  if gfx.mouse_cap&2==2 and last_mouse_cap&2==0 then mouse_ox,mouse_oy = gfx.mouse_x, gfx.mouse_y end
  if GUID_N then
    toTrack_N = reaper.BR_GetMediaTrackByGUID(0, GUID_N)
  end
  ------------------------------
  Draw()-- main draw function
    ------------------------------
    -- SnapShot_bypas_unbypas () --
    ------------------------------
    last_mouse_cap = gfx.mouse_cap
    gfx.update()
    char=gfx.getchar()
    if char == 32 then reaper.Main_OnCommand(40044,0) end
    if char >= 0  then reaper.defer(mainloop) end
    if char == -1 then
      timeout(0.5, function()
        SetButtonOFF()
      end)
    end
  end


  --------------------------------------------------------------------------------
  --------------------------------------------------------------------------------
  function StartComposition ()
    -- _, proj_nm = reaper.EnumProjects(-1, "") -- Отдаёт имя проекта НЕ ЛОКАЛЬНАЯ ПЕРЕМЕННАЯ, используется в других смежных скриптах
    proj_nm = reaper.GetProjectName( 0, "" )
    if proj_nm ~= "" then -- Если проект сохранялся ранее, то создётся папка с именем проекта в дирректории Scripts и Скрипт запускается в целом
      -- proj_nm = string.match(proj_nm, "%b\\.")
      proj_nm = string.sub(proj_nm, 0, -5)
      -- msg(proj_nm)

      CreateScriptFolder (proj_nm)



      -- Buttons from Project tracks--
      Buttons_from_Proj_tracks()
      --initialize--
      init()
      --Mainloop--
      mainloop()

      init_gfx(GUI_TB.title,GUI_TB.width,GUI_TB.height,GUI_TB.Wnd_Dock,GUI_TB.Wnd_X,GUI_TB.Wnd_Y)

      -- Loop()
    else                  -- Если проект не сохранялся ранее, то предлагается его сохранить до начала работы
      mesg = [=[После нажатия на OK
      вам будет предложенно сохранить текущий проект.
      Сделайте это, желательно с выбранной опцией -
      Create subdirectory for project - Это упорядочит ваши данные.]=]
      fff = reaper.MB(mesg , "ПРОЧТИТЕ ВНИМАТЕЛЬНО", 1)

      if fff == 1 then --Если пользователь ответил ОК, то предлагается сохранить проект и повторная проверка запускает скрипт
        --Если ответит Cansel - то скрипт просто не запустится
        reaper.Main_SaveProject(0, true) -- Если пользователь не сохранит проект, то цикл повторится
        reaper.defer(StartComposition)
      end
    end
  end

  ----------------------------------------------
  --- START ------------------------------------
  ----------------------------------------------
  StartComposition () -- Старт начальной функции

  SetButtonON()

  reaper.atexit(SetButtonOFF)
